glibmm: Gio::FileInfo Class Reference

glibmm 2.64.2

- Main Page
- Related Pages
- Modules
- Namespaces
- Classes
- Examples

- Class List
- Class Index
- Class Hierarchy
- Class Members

Public Member Functions | Static Public Member Functions | Related Functions | List of all members
Gio::FileInfo Class Reference

FileInfo implements methods for getting information that all files should contain, and allows for manipulation of extended attributes. More...

`#include <giomm/fileinfo.h>`

Inheritance diagram for Gio::FileInfo:
[legend]

## Public Member Functions
| FileInfo (FileInfo&& src) noexcept
FileInfo& | operator= (FileInfo&& src) noexcept
| ~FileInfo () noexcept override
GFileInfo* | gobj ()
| Provides access to the underlying C GObject. More...
const GFileInfo* | gobj () const
| Provides access to the underlying C GObject. More...
GFileInfo* | gobj_copy ()
| Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs. More...
| FileInfo ()
Glib::RefPtr< FileInfo > | dup () const
| Duplicates a file info structure. More...
void | copy_into (Glib::RefPtr< FileInfo >& dest_info) const
| First clears all of the [GFileAttribute][gio-GFileAttribute] of dest_info, and then copies all of the file attributes from src_info to dest_info. More...
bool | has_attribute (const std::string& attribute) const
| Checks if a file info structure has an attribute named attribute. More...
bool | has_namespace (const std::string& name_space) const
| Checks if a file info structure has an attribute in the specified name_space. More...
Glib::StringArrayHandle | list_attributes (const std::string& name_space) const
| Lists the file info structure's attributes. More...
Glib::StringArrayHandle | list_attributes () const
| A list_attributes() convenience overload. More...
FileAttributeType | get_attribute_type (const std::string& attribute) const
| Gets the attribute type for an attribute key. More...
void | remove_attribute (const std::string& attribute)
| Removes all cases of attribute from info if it exists. More...
FileAttributeStatus | get_attribute_status (const std::string& attribute) const
| Gets the attribute status for an attribute key. More...
std::string | get_attribute_string (const std::string& attribute) const
| Gets the value of a string attribute. More...
std::vector< Glib::ustring > | get_attribute_strings (const std::string& attribute) const
| Gets the value of a stringv attribute. More...
Glib::ustring | get_attribute_as_string (const std::string& attribute) const
| Gets the value of a attribute, formated as a string. More...
std::string | get_attribute_byte_string (const std::string& attribute) const
| Gets the value of a byte string attribute. More...
bool | get_attribute_boolean (const std::string& attribute) const
| Gets the value of a boolean attribute. More...
guint32 | get_attribute_uint32 (const std::string& attribute) const
| Gets an unsigned 32-bit integer contained within the attribute. More...
gint32 | get_attribute_int32 (const std::string& attribute) const
| Gets a signed 32-bit integer contained within the attribute. More...
guint64 | get_attribute_uint64 (const std::string& attribute) const
| Gets a unsigned 64-bit integer contained within the attribute. More...
gint64 | get_attribute_int64 (const std::string& attribute) const
| Gets a signed 64-bit integer contained within the attribute. More...
Glib::RefPtr< Glib::Object > | get_attribute_object (const std::string& attribute) const
| Gets the value of a Object attribute. More...
bool | set_attribute_status (const std::string& attribute, FileAttributeStatus status)
| Sets the attribute status for an attribute key. More...
void | set_attribute_string (const std::string& attribute, const std::string& attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_strings (const std::string& attribute, const std::vector< Glib::ustring >& attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_byte_string (const std::string& attribute, const std::string& attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_boolean (const std::string& attribute, bool attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_uint32 (const std::string& attribute, guint32 attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_int32 (const std::string& attribute, gint32 attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_uint64 (const std::string& attribute, guint64 attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_int64 (const std::string& attribute, gint64 attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | set_attribute_object (const std::string& attribute, const Glib::RefPtr< Glib::Object >& attr_value)
| Sets the attribute to contain the given attr_value, if possible. More...
void | clear_status ()
| Clears the status information from info. More...
Glib::DateTime | get_deletion_date () const
| Returns the DateTime representing the deletion date of the file, as available in G_FILE_ATTRIBUTE_TRASH_DELETION_DATE. More...
FileType | get_file_type () const
| Gets a file's type (whether it is a regular file, symlink, etc). More...
bool | is_hidden () const
| Checks if a file is hidden. More...
bool | is_backup () const
| Checks if a file is a backup file. More...
bool | is_symlink () const
| Checks if a file is a symlink. More...
std::string | get_name () const
| Gets the name for a file. More...
std::string | get_display_name () const
| Gets a display name for a file. More...
std::string | get_edit_name () const
| Gets the edit name for a file. More...
Glib::RefPtr< Icon > | get_icon ()
| Gets the icon for a file. More...
Glib::RefPtr< const Icon > | get_icon () const
| Gets the icon for a file. More...
Glib::RefPtr< Icon > | get_symbolic_icon ()
| Gets the symbolic icon for a file. More...
Glib::RefPtr< const Icon > | get_symbolic_icon () const
| Gets the symbolic icon for a file. More...
std::string | get_content_type () const
| Gets the file's content type. More...
goffset | get_size () const
| Gets the file's size. More...
Glib::TimeVal | modification_time () const
Glib::DateTime | get_modification_date_time () const
| Gets the modification time of the current info and returns it as a DateTime. More...
std::string | get_symlink_target () const
| Gets the symlink target for a given FileInfo. More...
std::string | get_etag () const
| Gets the [entity tag][gfile-etag] for a given FileInfo. More...
gint32 | get_sort_order () const
| Gets the value of the sort_order attribute from the FileInfo. More...
void | set_attribute_mask (const Glib::RefPtr< FileAttributeMatcher >& mask)
| Sets mask on info to match specific attribute types. More...
void | unset_attribute_mask ()
| Unsets a mask set by g_file_info_set_attribute_mask(), if one is set. More...
void | set_file_type (FileType type)
| Sets the file type in a FileInfo to type. More...
void | set_is_hidden (bool hidden=true)
| Sets the "is_hidden" attribute in a FileInfo according to hidden. More...
void | set_is_symlink (bool symlink=true)
| Sets the "is_symlink" attribute in a FileInfo according to symlink. More...
void | set_name (const std::string& name)
| Sets the name attribute for the current FileInfo. More...
void | set_display_name (const std::string& display_name)
| Sets the display name for the current FileInfo. More...
void | set_edit_name (const std::string& edit_name)
| Sets the edit name for the current file. More...
void | set_icon (const Glib::RefPtr< Icon >& icon)
| Sets the icon for a given FileInfo. More...
void | set_symbolic_icon (const Glib::RefPtr< Icon >& icon)
| Sets the symbolic icon for a given FileInfo. More...
void | set_content_type (const std::string& content_type)
| Sets the content type attribute for a given FileInfo. More...
void | set_size (goffset size)
| Sets the G_FILE_ATTRIBUTE_STANDARD_SIZE attribute in the file info to the given size. More...
void | set_modification_time (const Glib::TimeVal& mtime)
| Sets the G_FILE_ATTRIBUTE_TIME_MODIFIED and G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC attributes in the file info to the given time value. More...
void | set_modification_date_time (const Glib::DateTime& mtime)
| Sets the G_FILE_ATTRIBUTE_TIME_MODIFIED and G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC attributes in the file info to the given date/time value. More...
void | set_symlink_target (const std::string& symlink_target)
| Sets the G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET attribute in the file info to the given symlink target. More...
void | set_sort_order (gint32 sort_order)
| Sets the sort order attribute in the file info structure. More...
Public Member Functions inherited from Glib::Object
| Object (const Object&)=delete
Object& | operator= (const Object&)=delete
| Object (Object&& src) noexcept
Object& | operator= (Object&& src) noexcept
void* | get_data (const QueryQuark& key)
void | set_data (const Quark& key, void* data)
void | set_data (const Quark& key, void* data, DestroyNotify notify)
void | remove_data (const QueryQuark& quark)
void* | steal_data (const QueryQuark& quark)
Public Member Functions inherited from Glib::ObjectBase
| ObjectBase (const ObjectBase&)=delete
ObjectBase& | operator= (const ObjectBase&)=delete
void | set_property_value (const Glib::ustring& property_name, const Glib::ValueBase& value)
| You probably want to use a specific property_*() accessor method instead. More...
void | get_property_value (const Glib::ustring& property_name, Glib::ValueBase& value) const
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | set_property (const Glib::ustring& property_name, const PropertyType& value)
| You probably want to use a specific property_*() accessor method instead. More...
template<class PropertyType >
void | get_property (const Glib::ustring& property_name, PropertyType& value) const
| You probably want to use a specific property_*() accessor method instead. More...
void | connect_property_changed (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | connect_property_changed (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, const sigc::slot< void >& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
sigc::connection | connect_property_changed_with_return (const Glib::ustring& property_name, sigc::slot< void >&& slot)
| You can use the signal_changed() signal of the property proxy instead. More...
void | freeze_notify ()
| Increases the freeze count on object. More...
void | thaw_notify ()
| Reverts the effect of a previous call to freeze_notify(). More...
virtual void | reference () const
| Increment the reference count for this object. More...
virtual void | unreference () const
| Decrement the reference count for this object. More...
GObject* | gobj ()
| Provides access to the underlying C GObject. More...
const GObject* | gobj () const
| Provides access to the underlying C GObject. More...
GObject* | gobj_copy () const
| Give a ref-ed copy to someone. Use for direct struct access. More...
Public Member Functions inherited from sigc::trackable
| trackable () noexcept
| trackable (const trackable &src) noexcept
| trackable (trackable &&src)
| ~trackable ()
void | add_destroy_notify_callback (void *data, func_destroy_notify func) const
void | notify_callbacks ()
trackable & | operator= (const trackable &src)
trackable & | operator= (trackable &&src)
void | remove_destroy_notify_callback (void *data) const

## Static Public Member Functions
static GType | get_type ()
| Get the GType for this class, for use with the underlying GObject type system. More...

## Related Functions
(Note that these are not member functions.)
Glib::RefPtr< Gio::FileInfo > | wrap (GFileInfo* object, bool take_copy=false)
| A Glib::wrap() method for this object. More...
Related Functions inherited from Glib::Object
Glib::RefPtr< Glib::Object > | wrap (GObject* object, bool take_copy=false)

## Additional Inherited Members
Public Types inherited from Glib::Object
using | DestroyNotify = void(*)(gpointer data)
Public Types inherited from sigc::trackable
typedef internal::func_destroy_notify | func_destroy_notify
Protected Member Functions inherited from Glib::Object
| Object ()
| Object (const Glib::ConstructParams& construct_params)
| Object (GObject* castitem)
| ~Object () noexcept override
Protected Member Functions inherited from Glib::ObjectBase
| ObjectBase ()
| This default constructor is called implicitly from the constructor of user-derived classes, even if, for instance, Gtk::Button calls a different ObjectBase constructor. More...
| ObjectBase (const char* custom_type_name)
| A derived constructor always overrides this choice. More...
| ObjectBase (const std::type_info& custom_type_info)
| This constructor is a special feature to allow creation of derived types on the fly, without having to use g_object_new() manually. More...
| ObjectBase (ObjectBase&& src) noexcept
ObjectBase& | operator= (ObjectBase&& src) noexcept
virtual | ~ObjectBase () noexcept=0
void | initialize (GObject* castitem)
void | initialize_move (GObject* castitem, Glib::ObjectBase* previous_wrapper)

## Detailed Description

FileInfo implements methods for getting information that all files should contain, and allows for manipulation of extended attributes.

See FileAttribute for more information on how GIO handles file attributes.

To obtain a FileInfo for a File, use File::query_info() (or its async variant). To obtain a FileInfo for a file input or output stream, use FileInput::stream_query_info() or FileOutput::stream_query_info() (or their async variants).

FileAttributeMatcher allows for searching through a FileInfo for attributes.

## Constructor & Destructor Documentation

Gio::FileInfo::FileInfo | ( | FileInfo&& | src | ) |
| noexcept

Gio::FileInfo::~FileInfo | ( |  | ) |
| overridenoexcept

Gio::FileInfo::FileInfo | ( |  | ) |

## Member Function Documentation

void Gio::FileInfo::clear_status | ( |  | ) |

Clears the status information from info.

void Gio::FileInfo::copy_into | ( | Glib::RefPtr< FileInfo >& | dest_info | ) | const

First clears all of the [GFileAttribute][gio-GFileAttribute] of dest_info, and then copies all of the file attributes from src_info to dest_info.

Parameters

  dest_info | Destination to copy attributes to.

Glib::RefPtr<FileInfo> Gio::FileInfo::dup | ( |  | ) | const

Duplicates a file info structure.

Returns
  A duplicate FileInfo of other.

Glib::ustring Gio::FileInfo::get_attribute_as_string | ( | const std::string & | attribute | ) | const

Gets the value of a attribute, formated as a string.

This escapes things as needed to make the string valid UTF-8.

Parameters

  attribute | A file attribute key.

Returns
  A UTF-8 string associated with the given attribute, or `nullptr` if the attribute wasn’t set.

bool Gio::FileInfo::get_attribute_boolean | ( | const std::string & | attribute | ) | const

Gets the value of a boolean attribute.

If the attribute does not contain a boolean value, `false` will be returned.

Parameters

  attribute | A file attribute key.

Returns
  The boolean value contained within the attribute.

std::string Gio::FileInfo::get_attribute_byte_string | ( | const std::string & | attribute | ) | const

Gets the value of a byte string attribute.

If the attribute does not contain a byte string, `nullptr` will be returned.

Parameters

  attribute | A file attribute key.

Returns
  The contents of the attribute value as a byte string, or `nullptr` otherwise.

gint32 Gio::FileInfo::get_attribute_int32 | ( | const std::string & | attribute | ) | const

Gets a signed 32-bit integer contained within the attribute.

If the attribute does not contain a signed 32-bit integer, or is invalid, 0 will be returned.

Parameters

  attribute | A file attribute key.

Returns
  A signed 32-bit integer from the attribute.

gint64 Gio::FileInfo::get_attribute_int64 | ( | const std::string & | attribute | ) | const

Gets a signed 64-bit integer contained within the attribute.

If the attribute does not contain a signed 64-bit integer, or is invalid, 0 will be returned.

Parameters

  attribute | A file attribute key.

Returns
  A signed 64-bit integer from the attribute.

Glib::RefPtr<Glib::Object> Gio::FileInfo::get_attribute_object | ( | const std::string & | attribute | ) | const

Gets the value of a Object attribute.

If the attribute does not contain a Object, `nullptr` will be returned.

Parameters

  attribute | A file attribute key.

Returns
  A Object associated with the given attribute, or `nullptr` otherwise.

FileAttributeStatus Gio::FileInfo::get_attribute_status | ( | const std::string & | attribute | ) | const

Gets the attribute status for an attribute key.

Parameters

  attribute | A file attribute key.

Returns
  A FileAttributeStatus for the given attribute, or G_FILE_ATTRIBUTE_STATUS_UNSET if the key is invalid.

std::string Gio::FileInfo::get_attribute_string | ( | const std::string & | attribute | ) | const

Gets the value of a string attribute.

If the attribute does not contain a string, `nullptr` will be returned.

Parameters

  attribute | A file attribute key.

Returns
  The contents of the attribute value as a UTF-8 string, or `nullptr` otherwise.

std::vector<Glib::ustring> Gio::FileInfo::get_attribute_strings | ( | const std::string & | attribute | ) | const

Gets the value of a stringv attribute.

If the attribute does not contain a stringv, `nullptr` will be returned.

Since glibmm 2.22:

Parameters

  attribute | A file attribute key.

Returns
  The contents of the attribute value as a stringv, or `nullptr` otherwise. Do not free. These returned strings are UTF-8.

FileAttributeType Gio::FileInfo::get_attribute_type | ( | const std::string & | attribute | ) | const

Gets the attribute type for an attribute key.

Parameters

  attribute | A file attribute key.

Returns
  A FileAttributeType for the given attribute, or G_FILE_ATTRIBUTE_TYPE_INVALID if the key is not set.

guint32 Gio::FileInfo::get_attribute_uint32 | ( | const std::string & | attribute | ) | const

Gets an unsigned 32-bit integer contained within the attribute.

If the attribute does not contain an unsigned 32-bit integer, or is invalid, 0 will be returned.

Parameters

  attribute | A file attribute key.

Returns
  An unsigned 32-bit integer from the attribute.

guint64 Gio::FileInfo::get_attribute_uint64 | ( | const std::string & | attribute | ) | const

Gets a unsigned 64-bit integer contained within the attribute.

If the attribute does not contain an unsigned 64-bit integer, or is invalid, 0 will be returned.

Parameters

  attribute | A file attribute key.

Returns
  A unsigned 64-bit integer from the attribute.

std::string Gio::FileInfo::get_content_type | ( |  | ) | const

Gets the file's content type.

Returns
  A string containing the file's content type.

Glib::DateTime Gio::FileInfo::get_deletion_date | ( |  | ) | const

Returns the DateTime representing the deletion date of the file, as available in G_FILE_ATTRIBUTE_TRASH_DELETION_DATE.

If the G_FILE_ATTRIBUTE_TRASH_DELETION_DATE attribute is unset, `nullptr` is returned.

Since glibmm 2.36:

Returns
  A DateTime, or `nullptr`.

std::string Gio::FileInfo::get_display_name | ( |  | ) | const

Gets a display name for a file.

Returns
  A string containing the display name.

std::string Gio::FileInfo::get_edit_name | ( |  | ) | const

Gets the edit name for a file.

Returns
  A string containing the edit name.

std::string Gio::FileInfo::get_etag | ( |  | ) | const

Gets the [entity tag][gfile-etag] for a given FileInfo.

See G_FILE_ATTRIBUTE_ETAG_VALUE.

Returns
  A string containing the value of the "etag:value" attribute.

FileType Gio::FileInfo::get_file_type | ( |  | ) | const

Gets a file's type (whether it is a regular file, symlink, etc).

This is different from the file's content type, see g_file_info_get_content_type().

Returns
  A FileType for the given file.

Glib::RefPtr<Icon> Gio::FileInfo::get_icon | ( |  | ) |

Gets the icon for a file.

Returns
  Icon for the given info.

Glib::RefPtr<const Icon> Gio::FileInfo::get_icon | ( |  | ) | const

Gets the icon for a file.

Returns
  Icon for the given info.

Glib::DateTime Gio::FileInfo::get_modification_date_time | ( |  | ) | const

Gets the modification time of the current info and returns it as a DateTime.

This requires the G_FILE_ATTRIBUTE_TIME_MODIFIED attribute. If G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC is provided, the resulting DateTime will have microsecond precision.

Since glibmm 2.62:

Returns
  Modification time, or `nullptr` if unknown.

std::string Gio::FileInfo::get_name | ( |  | ) | const

Gets the name for a file.

Returns
  A string containing the file name.

goffset Gio::FileInfo::get_size | ( |  | ) | const

Gets the file's size.

Returns
  A #goffset containing the file's size.

gint32 Gio::FileInfo::get_sort_order | ( |  | ) | const

Gets the value of the sort_order attribute from the FileInfo.

See G_FILE_ATTRIBUTE_STANDARD_SORT_ORDER.

Returns
  A #gint32 containing the value of the "standard::sort_order" attribute.

Glib::RefPtr<Icon> Gio::FileInfo::get_symbolic_icon | ( |  | ) |

Gets the symbolic icon for a file.

Since glibmm 2.34:

Returns
  Icon for the given info.

Glib::RefPtr<const Icon> Gio::FileInfo::get_symbolic_icon | ( |  | ) | const

Gets the symbolic icon for a file.

Since glibmm 2.34:

Returns
  Icon for the given info.

std::string Gio::FileInfo::get_symlink_target | ( |  | ) | const

Gets the symlink target for a given FileInfo.

Returns
  A string containing the symlink target.

static GType Gio::FileInfo::get_type | ( |  | ) |
| static

Get the GType for this class, for use with the underlying GObject type system.

GFileInfo* Gio::FileInfo::gobj | ( |  | ) |
| inline

Provides access to the underlying C GObject.

const GFileInfo* Gio::FileInfo::gobj | ( |  | ) | const
| inline

Provides access to the underlying C GObject.

GFileInfo* Gio::FileInfo::gobj_copy | ( |  | ) |

Provides access to the underlying C instance. The caller is responsible for unrefing it. Use when directly setting fields in structs.

bool Gio::FileInfo::has_attribute | ( | const std::string & | attribute | ) | const

Checks if a file info structure has an attribute named attribute.

Parameters

  attribute | A file attribute key.

Returns
  `true` if info has an attribute named attribute, `false` otherwise.

bool Gio::FileInfo::has_namespace | ( | const std::string & | name_space | ) | const

Checks if a file info structure has an attribute in the specified name_space.

Since glibmm 2.22:

Parameters

  name_space | A file attribute namespace.

Returns
  `true` if info has an attribute in name_space, `false` otherwise.

bool Gio::FileInfo::is_backup | ( |  | ) | const

Checks if a file is a backup file.

Returns
  `true` if file is a backup file, `false` otherwise.

bool Gio::FileInfo::is_hidden | ( |  | ) | const

Checks if a file is hidden.

Returns
  `true` if the file is a hidden file, `false` otherwise.

bool Gio::FileInfo::is_symlink | ( |  | ) | const

Checks if a file is a symlink.

Returns
  `true` if the given info is a symlink.

Glib::StringArrayHandle Gio::FileInfo::list_attributes | ( | const std::string & | name_space | ) | const

Lists the file info structure's attributes.

Parameters

  name_space | A file attribute key's namespace, or `nullptr` to list all attributes.

Returns
  A null-terminated array of strings of all of the possible attribute types for the given name_space, or `nullptr` on error.

Glib::StringArrayHandle Gio::FileInfo::list_attributes | ( |  | ) | const

A list_attributes() convenience overload.

Glib::TimeVal Gio::FileInfo::modification_time | ( |  | ) | const

Deprecated:
  Use get_modification_date_time() instead.

FileInfo& Gio::FileInfo::operator= | ( | FileInfo&& | src | ) |
| noexcept

void Gio::FileInfo::remove_attribute | ( | const std::string & | attribute | ) |

Removes all cases of attribute from info if it exists.

Parameters

  attribute | A file attribute key.

void Gio::FileInfo::set_attribute_boolean | ( | const std::string & | attribute,
|  | bool | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | A file attribute key.
  attr_value | A boolean value.

void Gio::FileInfo::set_attribute_byte_string | ( | const std::string & | attribute,
|  | const std::string & | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | A file attribute key.
  attr_value | A byte string.

void Gio::FileInfo::set_attribute_int32 | ( | const std::string & | attribute,
|  | gint32 | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | A file attribute key.
  attr_value | A signed 32-bit integer.

void Gio::FileInfo::set_attribute_int64 | ( | const std::string & | attribute,
|  | gint64 | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | Attribute name to set.
  attr_value | Int64 value to set attribute to.

void Gio::FileInfo::set_attribute_mask | ( | const Glib::RefPtr< FileAttributeMatcher >& | mask | ) |

Sets mask on info to match specific attribute types.

Parameters

  mask | A FileAttributeMatcher.

void Gio::FileInfo::set_attribute_object | ( | const std::string & | attribute,
|  | const Glib::RefPtr< Glib::Object >& | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | A file attribute key.
  attr_value | A Object.

bool Gio::FileInfo::set_attribute_status | ( | const std::string & | attribute,
|  | FileAttributeStatus | status
| ) |  |

Sets the attribute status for an attribute key.

This is only needed by external code that implement g_file_set_attributes_from_info() or similar functions.

The attribute must exist in info for this to work. Otherwise `false` is returned and info is unchanged.

Since glibmm 2.22:

Parameters

  attribute | A file attribute key.
  status | A FileAttributeStatus.

Returns
  `true` if the status was changed, `false` if the key was not set.

void Gio::FileInfo::set_attribute_string | ( | const std::string & | attribute,
|  | const std::string & | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | A file attribute key.
  attr_value | A UTF-8 string.

void Gio::FileInfo::set_attribute_strings | ( | const std::string & | attribute,
|  | const std::vector< Glib::ustring >& | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Sinze: 2.22

Parameters

  attribute | A file attribute key.
  attr_value | A `nullptr` terminated array of UTF-8 strings.

void Gio::FileInfo::set_attribute_uint32 | ( | const std::string & | attribute,
|  | guint32 | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | A file attribute key.
  attr_value | An unsigned 32-bit integer.

void Gio::FileInfo::set_attribute_uint64 | ( | const std::string & | attribute,
|  | guint64 | attr_value
| ) |  |

Sets the attribute to contain the given attr_value, if possible.

Parameters

  attribute | A file attribute key.
  attr_value | An unsigned 64-bit integer.

void Gio::FileInfo::set_content_type | ( | const std::string & | content_type | ) |

Sets the content type attribute for a given FileInfo.

See G_FILE_ATTRIBUTE_STANDARD_CONTENT_TYPE.

Parameters

  content_type | A content type. See [GContentType][gio-GContentType].

void Gio::FileInfo::set_display_name | ( | const std::string & | display_name | ) |

Sets the display name for the current FileInfo.

See G_FILE_ATTRIBUTE_STANDARD_DISPLAY_NAME.

Parameters

  display_name | A string containing a display name.

void Gio::FileInfo::set_edit_name | ( | const std::string & | edit_name | ) |

Sets the edit name for the current file.

See G_FILE_ATTRIBUTE_STANDARD_EDIT_NAME.

Parameters

  edit_name | A string containing an edit name.

void Gio::FileInfo::set_file_type | ( | FileType | type | ) |

Sets the file type in a FileInfo to type.

See G_FILE_ATTRIBUTE_STANDARD_TYPE.

Parameters

  type | A FileType.

void Gio::FileInfo::set_icon | ( | const Glib::RefPtr< Icon >& | icon | ) |

Sets the icon for a given FileInfo.

See G_FILE_ATTRIBUTE_STANDARD_ICON.

Parameters

  icon | A Icon.

void Gio::FileInfo::set_is_hidden | ( | bool | hidden = `true` | ) |

Sets the "is_hidden" attribute in a FileInfo according to hidden.

See G_FILE_ATTRIBUTE_STANDARD_IS_HIDDEN.

Parameters

  hidden | A `bool`.

void Gio::FileInfo::set_is_symlink | ( | bool | symlink = `true` | ) |

Sets the "is_symlink" attribute in a FileInfo according to symlink.

See G_FILE_ATTRIBUTE_STANDARD_IS_SYMLINK.

Parameters

  symlink | A `bool`.

void Gio::FileInfo::set_modification_date_time | ( | const Glib::DateTime& | mtime | ) |

Sets the G_FILE_ATTRIBUTE_TIME_MODIFIED and G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC attributes in the file info to the given date/time value.

Since glibmm 2.62:

Parameters

  mtime | A DateTime.

void Gio::FileInfo::set_modification_time | ( | const Glib::TimeVal& | mtime | ) |

Sets the G_FILE_ATTRIBUTE_TIME_MODIFIED and G_FILE_ATTRIBUTE_TIME_MODIFIED_USEC attributes in the file info to the given time value.

Deprecated: 2.62: Use g_file_info_set_modification_date_time() instead, as TimeVal is deprecated due to the year 2038 problem.

Deprecated:
  Use set_modification_date_time() instead.

Parameters

  mtime | A TimeVal.

void Gio::FileInfo::set_name | ( | const std::string & | name | ) |

Sets the name attribute for the current FileInfo.

See G_FILE_ATTRIBUTE_STANDARD_NAME.

Parameters

  name | A string containing a name.

void Gio::FileInfo::set_size | ( | goffset | size | ) |

Sets the G_FILE_ATTRIBUTE_STANDARD_SIZE attribute in the file info to the given size.

Parameters

  size | A #goffset containing the file's size.

void Gio::FileInfo::set_sort_order | ( | gint32 | sort_order | ) |

Sets the sort order attribute in the file info structure.

See G_FILE_ATTRIBUTE_STANDARD_SORT_ORDER.

Parameters

  sort_order | A sort order integer.

void Gio::FileInfo::set_symbolic_icon | ( | const Glib::RefPtr< Icon >& | icon | ) |

Sets the symbolic icon for a given FileInfo.

See G_FILE_ATTRIBUTE_STANDARD_SYMBOLIC_ICON.

Since glibmm 2.34:

Parameters

  icon | A Icon.

void Gio::FileInfo::set_symlink_target | ( | const std::string & | symlink_target | ) |

Sets the G_FILE_ATTRIBUTE_STANDARD_SYMLINK_TARGET attribute in the file info to the given symlink target.

Parameters

  symlink_target | A static string containing a path to a symlink target.

void Gio::FileInfo::unset_attribute_mask | ( |  | ) |

Unsets a mask set by g_file_info_set_attribute_mask(), if one is set.

## Friends And Related Function Documentation

Glib::RefPtr< Gio::FileInfo > wrap | ( | GFileInfo * | object,
|  | bool | take_copy = `false`
| ) |  |
| related

A Glib::wrap() method for this object.

Parameters

  object | The C instance.
  take_copy | False if the result should take ownership of the C instance. True if it should take a new copy or ref.

Returns
  A C++ instance that wraps this C instance.